//
//  ViewController.m
//  弹簧效果
//
//  Created by CC on 16/8/13.
//  Copyright © 2016年 CC. All rights reserved.
//

#import "ViewController.h"

#define KScreenWidth  [UIScreen mainScreen].bounds.size.width
#define KScreenHeight [UIScreen mainScreen].bounds.size.height

#define Gap 0.9 *KScreenWidth

@interface ViewController ()
{
    UIButton *button1;
    UIButton *button2;
    UIButton *button3;
}
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor blackColor];
    [self layoutUI];
}

- (void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event {
    // iOS 9
//    [self springAnimation:button1];
//    [self springAnimation:button2];
//    [self springAnimation:button3];
    
    // iOS 7
    [self springAniamtion1];
}

#pragma mark -- iOS 7 的方法
// iOS 7 的方法
- (void)springAniamtion1 {
    
    [UIView animateWithDuration:0.1 delay:0 usingSpringWithDamping:100 initialSpringVelocity:8 options:UIViewAnimationOptionCurveEaseInOut animations:^{
        
        button1.frame = CGRectMake(KScreenWidth / 4 , KScreenHeight / 3, KScreenWidth / 3, KScreenHeight / 6 - 20);
        [self.view addSubview:button1];
        
        
    } completion:^(BOOL finished) {
        [self springAniamtion2];
    }];
    
}

- (void)springAniamtion2 {
    [UIView animateWithDuration:0.1 delay:0.05 usingSpringWithDamping:75 initialSpringVelocity:14 options:UIViewAnimationOptionCurveEaseInOut animations:^{
        
        button2.frame = CGRectMake(KScreenWidth / 4 , KScreenHeight / 2, KScreenWidth / 3, KScreenHeight / 6 - 20);
        [self.view addSubview:button2];
        
    } completion:^(BOOL finished) {
        [self springAniamtion3];
    }];
}

- (void)springAniamtion3 {
    [UIView animateWithDuration:0.1 delay:0.1 usingSpringWithDamping:50
          initialSpringVelocity:21 options:UIViewAnimationOptionCurveEaseInOut animations:^{
              
              button3.frame = CGRectMake(KScreenWidth / 4 , KScreenHeight * 2/ 3, KScreenWidth / 3, KScreenHeight / 6 - 20);
              [self.view addSubview:button3];
              
          } completion:^(BOOL finished) {
              
          }];
}

#pragma mark -- iOS 9 的方法
// iOS 9 的方法
- (void)springAnimation:(UIButton *)button
{
    CASpringAnimation *animation = [CASpringAnimation animationWithKeyPath:@"position.x"];
    animation.mass = 2.0;
    animation.stiffness = 20;
    animation.damping = 70.0;
    animation.initialVelocity = 6;
    animation.duration = animation.settlingDuration;
    [button.layer addAnimation:animation forKey:nil];
    button.frame = CGRectMake(KScreenWidth / 4 + Gap - Gap, button.frame.origin.y, button.frame.size.width, button.frame.size.height);
}

- (void)layoutUI {
    button1 = [UIButton buttonWithType:UIButtonTypeCustom];
    button1.frame = CGRectMake(KScreenWidth / 4 + Gap, KScreenHeight / 3, KScreenWidth / 3, KScreenHeight / 6 - 20);
    
    button2 = [UIButton buttonWithType:UIButtonTypeCustom];
    button2.frame = CGRectMake(KScreenWidth / 4 + Gap, KScreenHeight / 2, KScreenWidth / 3, KScreenHeight / 6 - 20);
    
    button3 = [UIButton buttonWithType:UIButtonTypeCustom];
    button3.frame = CGRectMake(KScreenWidth / 4 + Gap, KScreenHeight * 2/ 3, KScreenWidth / 3, KScreenHeight / 6 - 20);
    
    [self.view addSubview:button1];
    [self.view addSubview:button2];
    [self.view addSubview:button3];
    
    button1.backgroundColor = [UIColor cyanColor];
    button2.backgroundColor = [UIColor greenColor];
    button3.backgroundColor = [UIColor redColor];
}

@end
